package com.psb.ss;

import java.applet.Applet;
import java.awt.Insets;
import java.awt.Frame;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

public class Application extends Frame implements WindowListener {
    public static void main(String args[]) {
        if (args != null && args.length == 2 && args[0].length() > 0  && args[1].length() > 0) {
            try {
                new Application(Integer.parseInt(args[0]), args[1].trim().toLowerCase().startsWith("t"));
                return;
            } catch (Exception e) {}
        }
        System.out.println("Usage: [worldnumber<int>] [lowdetail<true/false>]");
    }

    private Application(int worldnumber, boolean lowdetail) {
        super("Pplsuqbawlz's PSB Loader : World " + worldnumber);
        System.out.print("Starting scarscape... ");
        try {
            World w = new World(worldnumber, lowdetail);
            System.out.println("Done.");
            this.setTitle("Pplsuqbawlz's PSB Loader : World " + worldnumber + " : " + w.getCodeBase().toString() + w.getParameter("archive"));
            LoaderSigned loader = new LoaderSigned(w.getCodeBase().toString() + w.getParameter("archive"));
            Applet app = (Applet) loader.loadClass(w.getParameter("code").replaceAll(".class", "")).newInstance();
            app.setStub(w);
            this.add("Center", app);
            this.addWindowListener(this);
            this.pack();
            Insets in = this.getInsets();
            this.setSize(in.right + in.left + Integer.parseInt(w.getParameter("width")), in.bottom + in.top + Integer.parseInt(w.getParameter("height")));
            this.setResizable(false);
            this.setVisible(true);
            app.init();
            w.active = true;
            app.start();
        } catch (Exception e) {
            System.out.println("Umm, error?\n\n");
            e.printStackTrace();
        }
    }

    public void windowOpened(WindowEvent e) {
    }

    public void windowClosing(WindowEvent e) {
        System.exit(0);
    }

    public void windowClosed(WindowEvent e) {
    }

    public void windowIconified(WindowEvent e) {
    }

    public void windowDeiconified(WindowEvent e) {
    }

    public void windowActivated(WindowEvent e) {
    }

    public void windowDeactivated(WindowEvent e) {
    }
}
